Attribute VB_Name = "Module1"
Option Explicit

Public cbo As ComboBox

Public Const LOCALE_SLANGUAGE As Long = &H2     'localized name of language
Public Const LOCALE_SSHORTDATE As Long = &H1F   'short date format string
Public Const LOCALE_SLONGDATE As Long = &H20    'long date format string

Public Const DATE_LONGDATE As Long = &H2
Public Const DATE_SHORTDATE As Long = &H1

Public Const HWND_BROADCAST As Long = &HFFFF&
Public Const WM_SETTINGCHANGE As Long = &H1A

Public Declare Function PostMessage Lib "user32" _
   Alias "PostMessageA" _
  (ByVal hwnd As Long, _
   ByVal wMsg As Long, _
   ByVal wParam As Long, _
   lParam As Any) As Long

Public Declare Function EnumDateFormats Lib "kernel32" _
   Alias "EnumDateFormatsA" _
  (ByVal lpDateFmtEnumProc As Long, _
   ByVal Locale As Long, _
   ByVal dwFlags As Long) As Long

Public Declare Sub CopyMemory Lib "kernel32" _
   Alias "RtlMoveMemory" _
  (Destination As Any, _
   Source As Any, _
   ByVal Length As Long)

Public Declare Function GetSystemDefaultLCID Lib "kernel32" () As Long

Public Declare Function GetLocaleInfo Lib "kernel32" _
   Alias "GetLocaleInfoA" _
  (ByVal Locale As Long, _
   ByVal LCType As Long, _
   ByVal lpLCData As String, _
   ByVal cchData As Long) As Long

Public Declare Function SetLocaleInfo Lib "kernel32" _
    Alias "SetLocaleInfoA" _
   (ByVal Locale As Long, _
    ByVal LCType As Long, _
    ByVal lpLCData As String) As Long


Public Function fGetUserLocaleInfo(ByVal lLocaleID As Long, _
            ByVal lLCType As Long) As String

Dim sReturn As String
Dim lReturn As Long
'
' Get the length of the desired date format item.
' To use this function, sReturn must be padded to
' the proper length. If it is not, this function
' will return the correct length.
'
lReturn = GetLocaleInfo(lLocaleID, lLCType, sReturn, Len(sReturn))
'
' If we got the buffer's length. Call the function again.
'
If lReturn Then
    '
    ' Pad the buffer with spaces.
    '
    sReturn = Space$(lReturn)
    '
    ' Now get the date.
    '
    lReturn = GetLocaleInfo(lLocaleID, lLCType, sReturn, Len(sReturn))
    '
    ' If successful, remove the trailing null.
    '
    If lReturn Then
        fGetUserLocaleInfo = Left$(sReturn, lReturn - 1)
    End If
End If
    
End Function


Public Function fEnumDates(lDateFormatString As Long) As Long
'
' This is a callback function for fEnumDateFormats
'
' It populates a the combobox assigned to global variariable
' cbo with the system's long date formats.
'
' Each time the system calls this function it fills
' lDateFormatString with the address of the string
' holding the date format. We need to go to that address
' and get the actual string.
'
cbo.AddItem fStringFromPointer(lDateFormatString)
'
' This function will continue to be called until
' there are no more date formates to enumerate or
' it returns zero. keep going.
'
fEnumDates = 1
End Function


Private Function fStringFromPointer(sString As Long) As String
Dim lPos    As Long
Dim sBuffer As String
'
' Pad a string to hold the data
'
sBuffer = Space$(128)
'
' Copy the string pointed to by the return value
' of the fEnumDates
'
Call CopyMemory(ByVal sBuffer, sString, ByVal Len(sBuffer))
'
' Remove the trailing null.
'
lPos = InStr(sBuffer, Chr$(0))

If lPos Then
    fStringFromPointer = Left$(sBuffer, lPos - 1)
End If
End Function
 

